<template>
  <div id="class_index_wrapper" class="bt-container">
    <h2 class="page-title">주제 목록</h2>
    <class-intro-table
      :list="list"
      :studyingClassList="studyingClassList || []"
      :onClick="onClick"
    />

  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import ClassIntroTable from '../partials/ClassIntroTable';
import utils from '../../utils';

export default {
  name: 'ClassIndex',
  components: {
    ClassIntroTable,
  },
  data() {
    return {
      userId: utils.getUserIdFromJwt(),
      searchType: 'name',
      searchText: '',
      list: [],
    };
  },
  computed: {
    ...mapState('NNclass', ['openedClassList', 'finishedClassList', 'studyingClassList']),
    authType() {
      const jwt = this.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  async created() {
    const vm = this;

    // 새로고침(Refresh, F5) 해도 목록을 가져올 수 있게 하는 부분.
    // 속도가 눈에 보이게 느려지므로 다른 방법이 있다면 수정 요구.
    await vm.getClassLists();
    vm.getMyClassLists();

    // 검색 기능 : 서버에서 DB 쿼리로 처리하는 게 효율이 나을 것 같으면 나중에 수정.
    if (vm.$route.query.type !== undefined) {
      vm.searchType = vm.$route.query.type;
    }
    if (vm.$route.query.text !== undefined) {
      vm.searchText = vm.$route.query.text;
    }
    // 열린 강의 탐색
    if (vm.openedClassList !== null) {
      for (let i = 0; i < vm.openedClassList.length; i += 1) {
        if (vm.searchType === 'name') {
          if (vm.openedClassList[i].name.includes(vm.searchText)) {
            vm.list.push(vm.openedClassList[i]);
          }
        }
        if (vm.searchType === 'teacher') {
          if (vm.openedClassList[i].master.name.includes(vm.searchText)) {
            vm.list.push(vm.openedClassList[i]);
          }
        }
      }
    }
    // 마감된 강의 탐색
    if (vm.finishedClassList !== null) {
      for (let i = 0; i < vm.finishedClassList.length; i += 1) {
        if (vm.finishedClassList[i].opened === 2) {
          if (vm.searchType === 'name') {
            if (vm.finishedClassList[i].name.includes(vm.searchText)) {
              vm.list.push(vm.finishedClassList[i]);
            }
          }
          if (vm.searchType === 'teacher') {
            if (vm.finishedClassList[i].master.name.includes(vm.searchText)) {
              vm.list.push(vm.finishedClassList[i]);
            }
          }
        }
      }
    }
  },
  methods: {
    ...mapActions('NNclass', [
      'getClassLists',
      'getMyClassLists',
      'postClassUser',
      'deleteClassUser',
    ]),
    formatDate: utils.formatDate,
    async onClick(type, arg) {
      const vm = this;
      switch (type) {
        case 'DETAIL': {
          vm.$router.push(`/class/${arg.class_id}/classdetail`);
          break;
        }
        case 'APPLY': {
          if (vm.authType !== 0) {
            vm.$notify({
              title: vm.$t('NOTIFY.LOGIN_REQ'),
              message: vm.$t('NOTIFY.ONLY_STD_SGN_UP'),
              type: 'warning',
              duration: 0,
            });
            vm.$router.push('/login');
          } else {
            try {
              await vm.postClassUser({
                classId: arg.class_id,
              });

              try {
                await vm.getMyClassLists();
              } catch (error) {
                vm.$notify({
                  title: vm.$t('NOTIFY.FAIL_IMP_SUBJ_LIST'),
                  message: error.toString(),
                  type: 'error',
                  duration: 0,
                });
              }
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.CR_SGN_UP_REQ_FL'),
                message: error.toString(),
                type: 'error',
                duration: 0,
              });
            }
          }
          break;
        }
        case 'CANCEL': {
          vm.$confirm(vm.$t('CONFIRM.WANT_CNL_CRS'), `${arg.name || ''} ` + vm.$t('CONFIRM.CANCEL_COURSE'), {
            confirmButtonText: vm.$t('NOTE.CONFIRM'),
            cancelButtonText: vm.$t('NOTIFY.CANCEL'),
            type: 'warning',
          })
          .then(async () => {
            try {
              await vm.deleteClassUser({
                classId: arg.class_id,
                userId: vm.userId,
              });

              vm.$notify({
                title: vm.$t('NOTIFY.CUR_CNCL_SUC'),
                message: vm.$t('NOTIFY.CUR_CNCLED'),
                type: 'success',
                duration: 3000,
              });
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.CUR_CNCL_FAIL'),
                message: error.toString(),
                type: 'error',
                duration: 3000,
              });
            }

            try {
              await vm.getMyClassLists();
              await vm.getClassLists();
            } catch (error) {
              vm.$notify({
                title: vm.$t('NOTIFY.FAIL_IMP_SUBJ_LIST'),
                message: error.toString(),
                type: 'error',
                duration: 0,
              });
            }
          })
          .catch(() => {
            vm.$notify({
              title: vm.$t('NOTIFY.INTERRUPTED'),
              message: vm.$t('NOTIFY.CUR_SGN_UP_INTRP'),
              type: 'info',
              duration: 3000,
            });
          });

          break;
        }
        case 'SEARCH': {
          vm.$router.push({ path: '/classes', query: { type: `${arg.searchType}`, text: `${arg.searchText}` } });
          break;
        }
        default: {
          throw new Error(`not defined type ${type}`);
        }
      }
    },
  },
};
</script>


<style lang="scss" scoped>

#class_index_wrapper {
  .page-title{
    float:left;
    width: 1000px;
    height: 24px;

    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;

    margin-top : 40px;
    margin-left : 12px;
    margin-bottom : 25px;
  }
}
</style>
